// Datei: serial.c
// Serielle Datenbertragung
//
// Holger Klabunde 
// 24.05.2001
// Compiler CC5x

#include "prozess.h"      /* Der verwendete Prozessor */
#include "protos.h"

//Das Winamp Plugin arbeitet mit
//9600Baud ,8 Bit ,kein Parity, 1 Stopbit
//Bei 9600 Baud braucht ein Bit 104us
//Achtung: am PIC hngt kein MAX232 oder sowas.
//Alle Bits invertiert senden,empfangen !!!

//Eigentlich mte BITTIME 26 fr 104us sein
//Aufgrund des Programmoverheads ist sie aber kleiner
//Bei mir ging es mit BITTIME=19 und 20. Grer oder kleiner nicht !

#define BITTIME		20 		//Zeit beim senden
//#define BITTIME		19 		//Zeit beim senden
#define BITHALFTIME 	BITTIME/2 	//Versatz 1/2 Bit beim empfangen	
#define BAUD96  	255-BITTIME	//Reload fr TMR0 bei ganzem Bit
#define BAUDHALF96  	255-BITHALFTIME	//Reload fr TMR0 bei halbem Bit

//########################
//Ein Datenbyte empfangen
//########################
unsigned char Receive()
{
 unsigned char by,i,mask;

 //Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b10000001; //Pullups off,Prescaler auf TMR0, 1:4

 by=0; //Empfangspuffer lschen
 mask=0x01; //Beginn bei LSB

 while(RX==0); //Warten auf das Startbit

//Zum abtasten ein halbes Bit Versatz einbringen
 TMR0=BAUDHALF96;
 T0IF=0;
 while(!T0IF); //Zeit abwarten

 for(i=0; i<8; i++)
  {
   TMR0=BAUD96;
   T0IF=0;
   while(!T0IF); //Zeit fr ein Bit abwarten

   if(!RX) by|=mask; //Invertiert !
   mask<<=1; //Nchstes Bit
  }

//Warten bis 1/2 Stopbit
 TMR0=BAUD96;
 T0IF=0;
 while(!T0IF); //Zeit fr ein Bit abwarten

//Stopbit abwarten
 while(RX);

 return by; //Daten zurckgeben !
}

//######################
//Ein Datenbyte senden
//######################
void Transmit(unsigned char dat)
{
 unsigned char by,i,mask;
 
 by=dat; 

 //Takt des PIC 4MHz, ein Zyklus = 1us
 OPTION=0b10000001; //Pullups off,Prescaler auf TMR0, 1:4

//Startbit senden
 TX=1; //Invertiert !
 TMR0=BAUD96;
 T0IF=0;
 while(!T0IF); //Zeit fr ein Bit abwarten

 mask=0x01; //Beginn bei LSB
 for(i=0; i<8; i++)
  {
   if(by&mask) TX=0;  //Invertiert !
   else        TX=1;  //Invertiert !
   TMR0=BAUD96;
   T0IF=0;
   while(!T0IF); //Zeit fr ein Bit abwarten
   
   mask<<=1; //Nchstes Bit
  }

//Stopbit senden
 TX=0; //Invertiert !
 TMR0=BAUD96;
 T0IF=0;
 while(!T0IF); //Zeit fr ein Bit abwarten
}

